Apptitle = "Magic Escape"
SeedRnd MilliSecs()
Graphics 800,600
Global timer = CreateTimer(60)

Const maxmapwidth = 23
Const maxmapheight = 16

Const tile_free = 0
Const tile_solid = 1
Const tile_halfmassive = 2
Const tile_diamond = 3
Const tile_playerspawn = 4

Global mapwidth
Global mapheight
Global mapdrawxoffset
Global mapdrawyoffset

Global playerx
Global playery
Global oldplayerx
Global oldplayery
Global playerdiamonds
Global playerspawnx
Global playerspawny
Global img_player = LoadImage("player.png")
Global playerlevel
Global playerlifes

Global itile_solid:TImage = LoadImage("solid.png")
Global itile_free:TImage = LoadImage("free.png")
Global itile_halfmassive:TImage = LoadImage("halfmassive.png")
Global itile_diamond:TImage = LoadImage("diamond.png")

Global igameover:TImage=LoadImage("gameover.png")

Type partikel
Field x#
Field y#
Field speed#
Field winkel#
Field time
End Type
Global partikel_list:TList = CreateList()

Global endgame

Global gamestate=0

Const gs_menu=0
Const gs_story=1
Const gs_game=2
Const gs_victory=3
Const gs_gameover=4

Const storylen = 9
Global storyarr$[storylen+2]
Local s:TStream=ReadFile("story")
For i=0 To storylen
	storyarr[i]=ReadLine(s)
Next
CloseFile s
Global showstory

Global ty#=160
Global tys#

Global frame

Global map:Int[ maxmapwidth, maxmapheight ]
Global countdiamonds

Local fstream:TStream = ReadFile("levels")
Global clvls=Int(ReadLine(fstream))
Global levels$[clvls]
For i = 0 To clvls-1
levels[i]=ReadLine(fstream)
Next
CloseFile fstream

While Not endgame
	
	Select gamestate
	Case 0
		menu()
	Case 1
		story()
	Case 2
		drawmap()
		drawplayer()
		drawother()
		controls()
	Case 3
		victory()
	Case 4
		gameover()
	End Select
	
	WaitTimer timer
	Flip 0
	Cls
	
Wend

End

Function menu()
ty#=ty#+tys#
tys#=tys#+0.1
If ty#>=160 Then tys#=-4

DrawText "Magic Escape",400-TextWidth("Magic Escape")/2,ty#
DrawText "Press Enter to start",400-TextWidth("Press Enter to start")/2,250
DrawText "Press Escape to end",400-TextWidth("Press Escape to end")/2,350
	
DrawLine 300,175,500,175

If KeyHit(key_enter) Then gamestate = gs_story ; FlushKeys() ; showstory=1 ; frame=0
If KeyHit(key_escape) Or AppTerminate() Then endgame=True
End Function

Function story()
frame:+1
If frame Mod 120=0 Then showstory:+1
If showstory>storylen+25 Then gamestate=gs_game
For i=0 To showstory
If i<=storylen+1 DrawText storyarr[i],400-TextWidth(storyarr[i])/2,600-showstory*25+i*25
Next
If GetChar()<>0 gamestate=gs_game;FlushKeys();playerdiamonds=0;playerlifes=5;playerlevel=0;loadmap(levels[0])
If AppTerminate() Then gamestate=gs_menu
DrawText "hit any key to skip",0,0
End Function

Function controls()
oldplayerx = playerx
oldplayery = playery
If KeyHit(key_left) Then moveplayer(-1,0)
If KeyHit(key_right) Then moveplayer(1,0)
If KeyHit(key_up) Then moveplayer(0,-1)
If KeyHit(key_down) Then moveplayer(0,1)
If KeyHit(key_r) Then loadmap(levels[playerlevel]);playerlifes:-1;playerdiamonds=0
If playerlifes=0 Then gamestate=gs_gameover
If KeyHit(key_escape) Or AppTerminate() Then gamestate=gs_menu;FlushKeys()
If KeyDown(key_1)And KeyDown(key_2) Then playerdiamonds=1;countdiamonds=0;playerlevel=Int(Input(""))
End Function

Function moveplayer(xm,ym)
i = map[playerx+xm,playery+ym]
If i=0 Or i=3 Or (i=2 And playerdiamonds > 0) playerx:+xm ; playery:+ym ; map[oldplayerx,oldplayery] = 2
If map[playerx,playery] = 2 Then map[playerx,playery]=0 ; playerdiamonds:-1
If map[playerx,playery] = 3 Then map[playerx,playery]=0 ; playerdiamonds:+1 ; countdiamonds:-1
If countdiamonds=0 Then
	If clvls=playerlevel+1 Then
		gamestate=gs_victory;frame=0;FlushKeys()
	Else
		playerlevel:+1 ; loadmap(levels[playerlevel]) ;playerdiamonds:-1
	EndIf
EndIf
End Function

Function victory()
DrawText "TOPDOWN-FEUERWERK!",15,15
If KeyHit(key_escape) Or AppTerminate() Or GetChar() <>0 Then gamestate=gs_menu;FlushKeys()
frame:+1
If frame Mod 60 = 0 Then
x=Rand(800)
y=Rand(600)
For i = 0 To 99
p:partikel=New partikel
ListAddLast(partikel_list,p)
p.x=x
p.y=y
p.speed=Rnd(1,3)
p.winkel=Rnd(360)
Next
EndIf
For p:partikel = EachIn partikel_list
p.time:+1
p.x=p.x+Cos(p.winkel)*p.speed
p.y=p.y+Sin(p.winkel)*p.speed
p.speed:*.99
DrawRect p.x,p.y,2,2
If p.time>= 90 Then partikel_list.Remove(p);p=Null
Next
End Function

Function gameover()
DrawImage igameover,280,225
If KeyHit(key_escape) Or AppTerminate() Or GetChar() <>0 Then gamestate=gs_menu;FlushKeys()
End Function

Function drawmap()
Local aImg:TImage
For x = 0 To mapwidth
	For y = 0 To mapheight
		Select map[x,y]
			Case tile_free
				aImg = itile_free
			Case tile_solid
				aimg = itile_solid
			Case tile_halfmassive
				aimg = itile_halfmassive
			Case tile_diamond
				aimg = itile_diamond
		End Select
		DrawImage aimg,mapdrawxoffset+x*32,mapdrawyoffset+y*32
	Next
Next
End Function

Function drawplayer()
	DrawImage img_player, mapdrawxoffset+playerx*32, mapdrawyoffset+playery*32
End Function

Function drawother()
	DrawText "Level " + (playerlevel+1), 15, 15
	DrawText "Leben: " + playerlifes, 15, 40
	DrawText "Diamanten: " + playerdiamonds, 15, 65
End Function

Function loadmap(filename$)
Local stream:TStream = ReadFile(filename)
Local firstline:Byte = True
Local linenumber:Byte
countdiamonds=0
While Not Eof(stream)
	line$ = ReadLine(stream)
	If firstline = True Then
		mapwidth = Len(line)-1
		firstline = False
	End If
	For i = 0 To mapwidth
		char$ = Mid(line$,i+1,1)
		If char$ = 4 Then
			playerspawnx = i
			playerspawny = linenumber
			playerx=playerspawnx
			playery=playerspawny
			char$ = 0
		End If
		map[i,linenumber]=Int(char$)
		If char$ = 3 Then countdiamonds:+1
	Next
	linenumber:+1
Wend
CloseFile stream
mapheight=linenumber-1
mapdrawxoffset = 400-mapwidth*16
mapdrawyoffset = 300-mapheight*16
End Function