Const housetop_size:Int = 140
Global housetop:TImage = LoadAnimImage("etc/gfx/ht.png", housetop_size, housetop_size, 0, 15)
Const PixelStep% = 12
Const CountStripesPerHouseFront% = 21 'variabel halten
Global housefrontstripes:TImage = LoadImage("etc/gfx/hf.png") 'variabel halten
'---------------------------------------------------------------------------------------------
Function draw_housefront(Point:Float[])
	'----------------------------------------------------------------------------------------
	Local DrawAngle:Float, Angle:Float[2], StepDistance:Float[2]
	'----------------------------------------------------------------------------------------
	Local Distance1:Float = Sqr( (Point[0]-Point[6])^2 + (Point[1]-Point[7])^2 )
	Local Distance2:Float = Sqr( (Point[4]-Point[2])^2 + (Point[5]-Point[3])^2 )
	Local OtherScale:Float = Distance1 / CountStripesPerHouseFront  'Max(1/12.0, ???
	'----------------------------------------
	Angle[0] = ATan2(Point[7] - Point[1], Point[6] - Point[0])
	Angle[1] = ATan2(Point[5] - Point[3], Point[4] - Point[2])
	StepDistance[0] = 1.0 * Distance1 / CountStripesPerHouseFront
	StepDistance[1] = 1.0 * Distance2 / CountStripesPerHouseFront
	'-----------------------------------------------------------------------------------
	Local x:Float[] = [Point[0], Point[2]]
	Local y:Float[] = [Point[1], Point[3]]
	'----------------------------------------
	x[0] = x[0] + StepDistance[0] * Cos(Angle[0])
	y[0] = y[0] + StepDistance[0] * Sin(Angle[0])
	x[1] = x[1] + StepDistance[1] * Cos(Angle[1])
	y[1] = y[1] + StepDistance[1] * Sin(Angle[1])
	DrawAngle = ATan2(y[1] - y[0], x[1] - x[0]) - 90
	Local yScale# = Sqr( (x[1]-x[0])^2 + (y[1]-y[0])^2 ) / 234.0
	'----------------------------------------
	Local Grey:Int = 24 + yScale * 176
	SetColor Grey, Grey, Grey
	DrawPoly(Point)
	SetColor 255,255,255
	'----------------------------------------
	Local i:Float = 1
	While i =< CountStripesPerHouseFront - 1
		SetRotation DrawAngle
		DrawSubImageRect(housefrontstripes, x[0], y[0],  OtherScale, yScale*234, (i Mod 5)*PixelStep, 0, PixelStep, 234)
		x[0] = x[0] + 2*StepDistance[0] * Cos(Angle[0])
		y[0] = y[0] + 2*StepDistance[0] * Sin(Angle[0])
		x[1] = x[1] + 2*StepDistance[1] * Cos(Angle[1])
		y[1] = y[1] + 2*StepDistance[1] * Sin(Angle[1])
		DrawAngle = ATan2(y[1] - y[0], x[1] - x[0]) - 90
		yScale = Sqr( (x[1]-x[0])^2 + (y[1]-y[0])^2 ) / 234.0
		i = i + 2
	Wend
	'----------------------------------------------------------------------------------------	
	SetRotation 0
End Function
'---------------------------------------------------------------------------------------------