Graphics3D 1024,768,32,2
SetBuffer BackBuffer()

SetFont LoadFont("Times New Roman",20)


SeedRnd MilliSecs()

AppTitle "BCC #46 - Fredko"

Global fps=CreateTimer(65)


Global sprite=LoadMesh("gfx/sprite.b3d")
HideEntity sprite


Global ma=LoadMesh("gfx/mann.3ds")
EntityRadius ma,0.4,0.8
EntityPickMode ma,1

Global mak=LoadMesh("gfx/mannkol.3ds")
EntityAlpha mak,0.0

HideEntity ma
HideEntity mak


AmbientLight 48,48,48

Global WELTlit=CreateLight()
RotateEntity weltlit,90,0,0
LightColor weltlit,16,16,16


Collisions 1,3,2,2
Collisions 2,3,2,2
Collisions 1,2,1,2
Collisions 2,2,1,2
Collisions 2,1,1,2
Collisions 2,3,2,2
Collisions 4,2,1,1
Collisions 2,4,1,1
Collisions 4,3,2,1
Type wfin
Field name$,mh,typ,mumagmax,nat,scmodus,scwarte,scanz,scstreu,scsmin,scsmax,scp,mhk,ges#,s,st,sound
End Type


Type wf
Field name$,mh,i,isprite,ipuls,typ,mumag,mumagmax,na,nat,nanat,scmodus,scwarte,scwartet,scanz,scstreu,scsmin,scsmax,scp,sound,mhk,ges#,s,st
End Type
Global wfin.wfin,wf.wf
Function Ladewfin()
dir=ReadDir("wf")

Repeat
dtname$=NextFile(dir)

If Right(dtname,3)=".wf"

dt=ReadFile("wf/"+dtname)

wfin=New wfin

wfin\name=rd(dt)
wfin\mh=LoadMesh("gfx/wf/"+rd(dt))
HideEntity wfin\mh

wfin\typ=rd(dt)

Select wfin\typ
Case 0
wfin\mumagmax=rd(dt)

wfin\nat=rd(dt)

wfin\scwarte=rd(dt)
wfin\scanz=rd(dt)
wfin\scstreu=rd(dt)

wfin\scsmin=rd(dt)
wfin\scsmax=rd(dt)

wfin\scp=CreatePivot()
x#=rd(dt)
y#=rd(dt)
z#=rd(dt)
PositionEntity wfin\scp,x,y,z

HideEntity wfin\mh

wfin\sound=Load3DSound("sfx/"+rd(dt))
Case 1
wfin\mhk=LoadMesh("gfx/wf/"+rd(dt))
HideEntity wfin\mhk

wfin\ges=rd(dt)

wfin\s=rd(dt)
wfin\st=rd(dt)

Default
RuntimeError "Ungltiger wfntyp"+Chr(13)+dtname+": "+wfin\typ
End Select

CloseFile dt

EndIf
Until dtname=""

CloseDir dir
End Function

Function Neuwf.wf(wfinname$)
For wfin=Each wfin
If Lower(wfin\name)=Lower(wfinname) Then Exit
Next
wf=New wf
wf\name=wfin\name
wf\mh=CopyEntity(wfin\mh)
wf\typ=wfin\typ
wf\i=1
wf\isprite=CopyMesh(sprite,wf\mh)
If wfin\typ=0
wf\scp=CopyEntity(wfin\scp,wf\mh)
wf\mumagmax=wfin\mumagmax
wf\mumag=wf\mumagmax
wf\nat=wfin\nat
wf\scmodus=wfin\scmodus
wf\scwarte=wfin\scwarte
wf\scanz=wfin\scanz
wf\scstreu=wfin\scstreu
wf\scsmin=wfin\scsmin
wf\scsmax=wfin\scsmax
wf\sound=wfin\sound
ElseIf wfin\typ=1
wf\mhk=CopyEntity(wfin\mhk,wf\mh)
EntityAlpha wf\mhk,0.0
wf\ges=wfin\ges
wf\s=wfin\s
wf\st=wfin\st
EndIf
Return wf
End Function

Function Updwfit()
taste_q=KeyHit(16)
For wf=Each wf
idist#=EntityDistance(wf\mh,imh)
If wf\i=1 And idist<=2
wf\ipuls=(wf\ipuls+1) Mod 360
i#=Sin(wf\ipuls)^2
EntityColor wf\isprite,255*i,0,0
ScaleEntity wf\isprite,i+0.5,1,i+0.5
Else
If wf\i=1 Then wf\ipuls=0:EntityColor wf\isprite,0,0,0
EndIf
If wf\i=1 And idist<=2 And taste_q

If wf\typ=0 And i1=Null

wf\i=-1

HideEntity wf\isprite
HideEntity wf\mh

i1=wf

ElseIf wf\typ=0 And i1<>Null And itaus=0

wf\i=-1

i1\i=1
PositionEntity i1\mh,0,0,0
RotateEntity i1\mh,0,0,0
EntityParent i1\mh,wf\mh,0
EntityParent i1\mh,0

ShowEntity i1\isprite
RotateEntity i1\isprite,0,0,0,1
ShowEntity i1\mh

HideEntity wf\isprite
HideEntity wf\mh

i1=wf

itaus=1

EndIf

If wf\typ=1 And i2=Null

wf\i=-1

HideEntity wf\isprite
HideEntity wf\mh

i2=wf

ElseIf wf\typ=1 And i2<>Null And itaus=0
wf\i=-1

i2\i=1
PositionEntity i2\mh,0,0,0
RotateEntity i2\mh,0,0,0
EntityParent i2\mh,wf\mh,0
EntityParent i2\mh,0

ShowEntity i2\isprite
RotateEntity i2\isprite,0,0,0,1
ShowEntity i2\mh

HideEntity wf\isprite
HideEntity wf\mh

i2=wf

itaus=1

EndIf

EndIf

Next

End Function

Function Updwfi()

CameraPick ikam,MouseX(),MouseY()

PositionEntity ip,PickedX(),PickedY(),PickedZ()

PointEntity imh,ip
RotateEntity imh,0,EntityYaw(imh),0

If iwf=0 And i1<>Null

iwf=1

ElseIf iwf=0 And i2<>Null

iwf=2

EndIf

mouse=MouseDown(1)

If i1<>Null And i2<>Null And MouseZSpeed()<>0 And Animating(ihand)=0

iwf=3-iwf

EndIf

If iwf<>iwfalt And Animating(ihand)=0
If iwfalt=1
HideEntity i1\mh
ShowEntity i2\mh
ElseIf iwfalt=2
HideEntity i2\mh
ShowEntity i1\mh
EndIf
EndIf

If iwf=1 And i1<>Null
If i1\i=-1

i1\i=0

PositionEntity i1\mh,0,0,0
EntityParent i1\mh,ihandwf,0
ShowEntity i1\mh

ElseIf i1\i=0

PointEntity i1\mh,ip
RotateEntity i1\mh,0,EntityYaw(imh),0,1

If i1\na=1 And i1\nanat<=MilliSecs()

i1\na=0

i1\mumag=i1\mumagmax

ElseIf mouse And i1\mumag>0 And i1\na=0 And i1\scwartet<=MilliSecs()

i1\mumag=i1\mumag-1

i1\scwartet=MilliSecs()+i1\scwarte

For i=1 To i1\scanz

s=New sc

s\mh=CopyEntity(scmh,i1\scp)
EntityParent s\mh,0
streu#=i1\scstreu
TurnEntity s\mh,Rnd(-streu,streu),Rnd(-streu,streu),0
EntityRadius s\mh,0.1
EntityType s\mh,4

s\s=Rand(i1\scsmin,i1\scsmax)
EmitSound i1\sound,i1\scp

Next

ElseIf ((mouse And i1\mumag=0) Or KeyHit(19)) And i1\na=0

i1\na=1
i1\nanat=MilliSecs()+i1\nat

EndIf

EndIf

ElseIf iwf=2 And i2<>Null

If i2\i=-1

i2\i=0

PositionEntity i2\mh,0,0.3,0
RotateEntity i2\mh,0,180,0

EntityParent i2\mh,ihandwf,0
ShowEntity i2\mh

ElseIf i2\i=0

anim=Animating(ihand)
animt=AnimTime(ihand)


If anim=0 And mouse

Animate ihand,3,i2\ges,Rand(2,3)

ElseIf anim=1 And animt>=6 And animt=<11

For zo=Each zo

If EntityDistance(i2\mhk,zo\mh)=<2

If MeshesIntersect(i2\mhk,zo\mhk)

szo(zo,i2\s,i2\s*Rnd(10,20),1,i2\st)

EndIf

EndIf

Next

EndIf

EndIf

EndIf


iwfalt=iwf
End Function
Type sc
Field mh,s
End Type

Global s.sc,scmh=LoadMesh("gfx/schuss.b3d")
HideEntity scmh
Function Updsc()

For s=Each sc
del=0

MoveEntity s\mh,0,0,1

If EntityCollided(s\mh,2)

del=1

szo Object.zo(EntityName(EntityCollided(s\mh,2))),s\s,s\s*Rnd(3,5)

ElseIf EntityCollided(s\mh,3)

del=1

EndIf

If del

FreeEntity s\mh

Delete s

EndIf

Next

End Function
Type zo
Field mh,mhk,spawnid,le,st,l,kimodus,kiaktion,kit,kiges#,attt
End Type

Global zo.zo,zozo.zo,zosound[6],zoblut=LoadMesh("gfx/blut.b3d"),zobluttex=LoadAnimTexture("gfx/blut.png",5,64,64,0,8)
For i=0 To 6
zosound[i]=Load3DSound("sfx/quiek"+i+".mp3")
Next
HideEntity zoblut
Type piv
Field p,typ,spawnid,modus,rad#,min,max
End Type
Global p.piv,pp.piv

Function Neuzo(p,rad#=1,spawnid=0,modus=-1)

zo=New zo

zo\mh=CopyEntity(ma):NameEntity zo\mh,Handle(zo)
EntityParent zo\mh,p,0
gr=Rand(64,192)
EntityColor zo\mh,gr,gr,gr

zo\mhk=CopyEntity(mak,zo\mh)

PositionEntity zo\mh,0,1,0

EntityType zo\mh,1


MoveEntity zo\mh,Rnd(-rad,rad),0,Rnd(-rad,rad)

TurnEntity zo\mh,0,Rand(0,360),0

EntityType zo\mh,2

EntityParent zo\mh,0

zo\le=Rand(50,150)

zo\kimodus=modus

If kimodus=-1 Then HideEntity zo\mh

End Function

Function Updzo()

For zo=Each zo

If zo\l<0 Then zo\l=0

zo\l=zo\l+1

If zo\l>360 Then zo\l=360

idist#=EntityDistance(zo\mh,imh)
ms=MilliSecs()

If zo\kimodus=-1 And idist<=24

ShowEntity zo\mh

zo\kimodus=0

ElseIf zo\kimodus>-1

TranslateEntity zo\mh,0,-0.05,0

EndIf

If zo\kimodus=0 And zo\kiaktion=0 And zo\kit<=ms

TurnEntity zo\mh,0,Rand(270,450),0

zo\kiaktion=1
zo\kit=ms+Rand(2,20)*250
zo\kiges=Rnd(0.01,0.1)



ElseIf zo\kimodus=0 And zo\kiaktion=1 And zo\kit<=ms

zo\kiaktion=0

zo\kit=ms+Rand(1,10)*250

zo\l=0

If Rand(0,1)=0
kanal=EmitSound(zosound[Rand(6)],zo\mh)
ChannelPitch kanal,Rand(2000,8000)
EndIf
EndIf

If zo\kimodus=0 And zo\kiaktion=1 And zo\kit>ms

MoveEntity zo\mh,0,0,zo\kiges*Sin(zo\l/4.0)

EndIf

If zo\kimodus=0 And idist<6

zo\kimodus=1

EndIf

If zo\kimodus=1

PointEntity zo\mh,imh
RotateEntity zo\mh,0,EntityYaw(zo\mh),0

MoveEntity zo\mh,0,0,0.1*Sin(zo\l/4.0)

If idist=<2 And zo\attt=<ms

zo\attt=ms+250*Rnd(1,8)

saden=Rand(100,500)
ile=ile-saden
il=il-saden/10*Rnd(1,10)

EndIf

EndIf

If zo\le<=0 Or (idist=>48 And zo\kimodus>-1)

FreeEntity zo\mh

Delete zo

EndIf

Next

End Function


Function UpdTrigger()

For p=Each piv
If p\typ=1

idist#=EntityDistance(p\p,imh)

If idist=<p\rad And p\modus=0 And p\spawnid>0 And (p\min+p\max)>0

p\modus=1

spanz=0

For pp=Each piv

If pp\spawnid=p\spawnid And pp\typ=0

spanz=spanz+1

EndIf

Next

If spanz>0

For pp=Each piv

If pp\spawnid=p\spawnid And pp\typ=0

zoanz=Rand(p\min,p\max)/spanz

For i=1 To zoanz

Neuzo(pp\p,pp\rad,pp\spawnid,1)

Next

EndIf

Next

EndIf

EndIf

EndIf
Next

End Function

Function szo(zos.zo,s,l=0,styp=0,st=0)

If styp=0 Or (styp=1 And zos\st=<MilliSecs())

If Rand(0,1)=0
kanal=EmitSound(zosound[Rand(6)],zos\mh)
ChannelPitch kanal,Rand(2000,16000)
EndIf

zos\le=zos\le-s
zos\l=zos\l-l
zos\st=MilliSecs()+st
zos\kimodus=1

blut=CopyEntity(zoblut,zos\mh)
RotateEntity blut,Rand(0,-18)*10,Rand(36)*10,0
TranslateEntity blut,0,0.4,0
EntityTexture blut,zobluttex,0,Rand(7)

EndIf

End Function

Function rd$(stream)
Return ReadLine(stream)
End Function


Global pstart=CreatePivot(),pziel=CreatePivot(),pzielrad#=1,pstartinfo$,pzielinfo$


Function Ladelv(lvl$)
pstartinfo=lvl
dt=ReadFile("lvl/"+lvl)

Repeat
rr$=rd(dt)

Select Lower(rr)
Case "pivstart"

x#=rd(dt)
y#=rd(dt)
y=y+1
z#=rd(dt)

PositionEntity pstart,x,y,z

Case "pivziel"

x#=rd(dt)
y#=rd(dt)
z#=rd(dt)
rad#=rd(dt)
info$=rd(dt)

PositionEntity pziel,x,y,z
pzielrad=rad
pzielinfo=info

Case "objekt"

obname$=rd(dt)

x#=rd(dt)
y#=rd(dt)
z#=rd(dt)
pitch#=rd(dt)
yaw#=rd(dt)
roll#=rd(dt)

obin=NameobInfo(obname)

If obin<>Null

ob=New ob

ob\mh=CopyEntity(obin\mh)

PositionEntity ob\mh,x,y,z
RotateEntity ob\mh,pitch,yaw,roll

If obin\kmh<>0 Then ob\kmh=CopyEntity(obin\kmh,ob\mh):EntityParent ob\kmh,0:EntityPickMode ob\kmh,2

EndIf

Case "pivspawn"


p=New piv

p\spawnid=rd(dt)

p\p=Createpivot()
x#=rd(dt)
y#=rd(dt)+1
z#=rd(dt)
PositionEntity p\p,x,y,z

p\rad=rd(dt)

p\min=rd(dt)
p\max=rd(dt)

Case "pivtrigger"

p=New piv

p\typ=1

p\spawnid=rd(dt)

p\p=CreatePivot()
x#=rd(dt)
y#=rd(dt)+0.8
z#=rd(dt)
PositionEntity p\p,x,y,z

p\rad=rd(dt)

p\min=rd(dt)
p\max=rd(dt)

Case "waffe"

wfname$=rd(dt)

wfx#=rd(dt)
wfy#=rd(dt)
wfz#=rd(dt)
wfpitch#=rd(dt)
wfyaw#=rd(dt)
wfroll#=rd(dt)

wf=Neuwf(wfname)

PositionEntity wf\mh,wfx,wfy,wfz
RotateEntity wf\mh,wfpitch,wfyaw,wfroll
RotateEntity wf\isprite,0,0,0,1



Case ""
Exit
End Select

Until rr=""

CloseFile dt

EntityType imh,0

EntityParent imh,pstart,0
PositionEntity imh,0,0,0
EntityParent imh,0

EntityType imh,1

For p=Each piv

If p\min+p\max>0 And p\typ=0

anz=Rand(p\min,p\max)

For i=1 To anz

Neuzo(p\p,p\rad)

Next

EndIf

Next

End Function

Type obinfo
Field name$,mh,kmh
End Type

Type ob
Field mh,kmh
End Type

Global obin.obinfo,ob.ob


Function LadeobInfo()
obdir=ReadDir("ob")
Repeat
dtname$=NextFile(obdir)

If Right(dtname,3)=".ob"

dt=ReadFile("ob/"+dtname)

obin=New obinfo
obin\name=rd(dt)
obin\mh=LoadMesh("gfx/ob/"+rd(dt))
k$=rd(dt)

If k<>""
obin\kmh=LoadMesh("gfx/ob/"+k)
EntityType obin\kmh,3
EntityPickMode obin\kmh,2
EntityAlpha obin\kmh,0.0
HideEntity obin\kmh
EndIf

HideEntity obin\mh


CloseFile dt

EndIf
Until dtname=""

CloseDir obdir
End Function

Function NameobInfo.obinfo(name$)

For obin=Each obinfo
If Lower(obin\name)=Lower(name) Then Return obin
Next
End Function


Global imh=CopyEntity(ma),iohr=CreateListener(imh,.1,1,1),ip=CreatePivot(),ile=10000,il,itaus,ipulsi,ihand=LoadAnimMesh("gfx/hand.b3d",imh),ihandwf=FindChild(FindChild(FindChild(ihand,"Schulter.R"),"Arm.R"),"Hand.R"),i1.wf,i2.wf,iwf,iwfalt
ExtractAnimSeq(ihand,1,1):ExtractAnimSeq(ihand,1,16):ExtractAnimSeq(ihand,16,31)

Global ikam=CreateCamera(),igrissel=LoadMesh("gfx/grissel.b3d",ikam),ipuls=LoadMesh("gfx/puls.b3d",ikam)

CameraFogMode ikam,1
CameraFogRange ikam,12,16
LadeobInfo
Ladewfin

Ladelv "tut0.lvl"

Repeat
WaitTimer fps
Cls

If EntityDistance(pziel,imh)=<pzielrad

If pzielinfo<>""

Neulv(pzielinfo)

Else

Cls

SetFont LoadFont("Times New Roman",100,1)


Text 400,300,"Spielende"

Flip

Delay 5000
End

EndIf

EndIf

itaus=0

iBew

Updwfit

Updwfi

UpdTrigger

Updsc

Updzo
UpdateWorld

PositionEntity ikam,EntityX(imh),EntityY(imh)+8,EntityZ(imh)-4
PointEntity ikam,imh

For ob=Each ob

If EntityDistance(ob\mh,imh)=>24
HideEntity ob\mh
Else
ShowEntity ob\mh
EndIf

Next

ile=ile+1
If ile>10000 Then ile=10000

ipulsi=(ipulsi+1+(10000-ile)/10000.0*19)Mod 360
ips#=Sin(ipulsi)*0.25+1

PositionEntity igrissel,Rnd(2),Rnd(2),1.1
PositionEntity ipuls,0,0,1.1
ScaleEntity ipuls,ips,ips,ips

RenderWorld

Color 192,192,192
If i2<>Null Then Text 100,500,i2\name
If i1<>Null Then Text 100,580,i1\name:Text 100,600,i1\mumag+"/"+i1\mumagmax

For wf=Each wf

If wf\i=1 And EntityDistance(imh,wf\mh)=<2

CameraProject ikam,EntityX(wf\mh),EntityY(wf\mh)+1,EntityZ(wf\mh)

Color 255,0,0
Text ProjectedX()-Len(wf\name)/2,ProjectedY(),wf\name
EndIf

Next

If ile<0 Then Neulv(pstartinfo)

Flip 0
Until KeyHit(1)
End


Function iBew()
If il<0 Then il=0

il=il+1

If il>360 Then il=360

MoveEntity imh,0,-0.05,0

bewx=KeyDown(32)-KeyDown(30)
bewz=KeyDown(17)-KeyDown(31)

If (Abs(bewx)+Abs(bewz))>0
RotateEntity imh,0,ATan2(bewz,bewx)-90,0
MoveEntity imh,0,0,0.2*Sin(il/4.0)*(ile/10000.0)
RotateEntity imh,0,0,0
EndIf
End Function

Function Neulv(lvl$)
For ob=Each ob
FreeEntity ob\mh
If ob\kmh<>0 Then FreeEntity ob\kmh
Delete ob
Next

For zo=Each zo
FreeEntity zo\mh
Delete zo
Next

For wf=Each wf
FreeEntity wf\mh
Delete wf
Next

i1=Null
i2=Null
iwf=0
iwfalt=0
il=0
ile=10000

For s=Each sc
FreeEntity s\mh
Delete s
Next

For p=Each piv
FreeEntity p\p
Delete p
Next

Ladelv lvl
End Function